using Indotalent.Infrastructure.Database;
using MediatR;
using Microsoft.EntityFrameworkCore;

namespace Indotalent.Features.Thirdparty.Vendor.Cqrs;

public record DeleteVendorContactCommand(string Id) : IRequest<bool>;

public class DeleteVendorContactHandler : IRequestHandler<DeleteVendorContactCommand, bool>
{
    private readonly AppDbContext _context;

    public DeleteVendorContactHandler(AppDbContext context) => _context = context;

    public async Task<bool> Handle(DeleteVendorContactCommand request, CancellationToken cancellationToken)
    {
        var entity = await _context.VendorContact
            .FirstOrDefaultAsync(x => x.Id == request.Id, cancellationToken);

        if (entity == null)
        {
            return false;
        }

        _context.VendorContact.Remove(entity);
        await _context.SaveChangesAsync(cancellationToken);

        return true;
    }
}